<template>
  <div class="gl-page-content">
    <div class="table">
      <BaseTable
        ref="baseTableRef"
        tableName="SYSTEM_TENANT"
        :api="tenantListApi"
        :exportApi="tenantExportApi"
        exportFileName="租户列表"
        :actionList="actionList"
      >
        <template #leftOptions>
          <el-button type="primary" :icon="Plus" @click="openDetailFun('')">新增租户</el-button>
        </template>
        <template #status="{ row }">
          {{ TENANT_STATUS.O[row.status] }}
        </template>
      </BaseTable>
    </div>
    <Detail v-model="detailVisible" :id="tenentId" tableName="SYSTEM_TENANT" @submit="submitFun" />
  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { Plus } from '@element-plus/icons-vue';
import { ElMessage } from 'element-plus';
import BaseTable from '@/components/common/table/baseTable.vue';
import Detail from './components/detail.vue';
import { tenantListApi, tenantDeleteApi, tenantExportApi } from '@/api/system/tenant';
import { useDict } from '@/utils/useDict';
import { useI18n } from 'vue-i18n';

const { t } = useI18n();
const { TENANT_STATUS } = useDict('TENANT_STATUS');
const actionList = ref([
  {
    title: t('通用.编辑'),
    type: 'primary',
    click: (row: any) => {
      openDetailFun(row.id);
    },
  },
  {
    title: t('通用.删除'),
    needConfirm: true,
    confirmTip: t('通用.确认删除吗'),
    type: 'danger',
    click: (row: any) => {
      delFun(row.id);
    },
  },
]);
const detailVisible = ref(false);
const baseTableRef = ref<any>();
const tenentId = ref<number | string>('');

const openDetailFun = (id: number | string) => {
  tenentId.value = id;
  detailVisible.value = true;
};

const submitFun = () => {
  baseTableRef.value.resetFun();
};

const delFun = (id: number) => {
  const params = {
    id,
  };
  tenantDeleteApi(params).then((res: any) => {
    if (res.code === 200) {
      baseTableRef.value.resetFun();
      ElMessage.success('操作成功');
    }
  });
};
</script>
